unit rvhtmltest1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RVScroll, RichView, RVStyle, rvhtmlimport, ExtCtrls, StdCtrls, jpeg, CRVFData,
  RVTypes{, GifImg, PngImage};

type
  TForm1 = class(TForm)
    RVStyle1: TRVStyle;
    RichView1: TRichView;
    RvHtmlImporter1: TRvHtmlImporter;
    Memo1: TMemo;
    Splitter1: TSplitter;
    Panel1: TPanel;
    btnOpen: TButton;
    OpenDialog1: TOpenDialog;
    btnPaste: TButton;
    procedure btnOpenClick(Sender: TObject);
    procedure RichView1Jump(Sender: TObject; id: Integer);
    procedure btnPasteClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.btnOpenClick(Sender: TObject);
var s: TRVRawByteString;
    Stream: TFileStream;
begin

  //RvHtmlImporter1.Encoding := rvhtmleUTF8;
  if OpenDialog1.Execute then
  begin
    Screen.Cursor := crHourGlass;
    try
      Stream := TFileStream.Create(OpenDialog1.FileName, fmOpenRead);
      try
        SetLength(s, Stream.Size);
        Stream.ReadBuffer(PRVAnsiChar(s)^, Length(s));
      finally
        Stream.Free;
      end;
      if RvHtmlImporter1.Encoding=rvhtmleUTF8 then
        Memo1.Lines.Text := UTF8ToAnsi(s) //Change to UTF8ToString(s) for Delphi 2009+
      else
        Memo1.Lines.Text := String(TRVAnsiString(s));
      RvHtmlImporter1.BasePath := ExtractFilePath(OpenDialog1.FileName);
      RvHtmlImporter1.LoadHtml(s);
      RvHtmlImporter1.BasePath := '';
    finally
      RichView1.Format;
      Screen.Cursor := crDefault;
    end;
  end;
end;

procedure TForm1.btnPasteClick(Sender: TObject);
begin
  try
    Screen.Cursor := crHourGlass;
    RvHtmlImporter1.LoadFromClipboard;
  finally
    RichView1.Format;
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.RichView1Jump(Sender: TObject; id: Integer);
var
  RVData: TCustomRVFormattedData;
  ItemNo: Longint;
begin
  RichView1.GetJumpPointLocation(id, RVData, ItemNo);
  MessageBox(Handle, PChar(RVData.GetItemTag(ItemNo)), 'Link!', MB_OK);
end;


end.
